﻿using HELLo_World.MapData.Buildings;
using HELLo_World.MapData.People;
using System;
using System.Collections.Generic;

namespace HELLo_World.MapData
{
    public class GameMap
    {
        #region Constants

        private const Int32 startingMoney = 10000;
        private const Int32 startingTicket = 50;

        #endregion

        #region Properties

        public String Name { get; private set; }

        public Int32 Money { get; set; }

        public Int32 Ticket { get; set; }

        public Int32 Time { get; set; }

        public List<Building> Buildings { get; set; }

        public List<Repairman> Repairmen { get; set; }

        public List<Visitor> Visitors { get; set; }

        #endregion

        #region Constructor

        public GameMap(String name)
        {
            Name = name;
            Money = startingMoney;
            Ticket = startingTicket;
            Time = 0;
            Buildings = new List<Building>();
            Repairmen = new List<Repairman>();
            Visitors = new List<Visitor>();
        }

        #endregion
    }
}
