﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HELLo_World.MapData.People
{
    public class Visitor : Person
    {
        #region Constants

        public static readonly Int32 MinMoney = 100;
        public static readonly Int32 MaxMoney = 1000;

        private Int32 _foodLevel;
        private Int32 _happinessLevel;

        #endregion

        #region Properties

        public Int32 CurrentInteractionTimeLeft { get; set; }

        public Int32 AdrenalinLevel { get; private set; }

        public Int32 FoodLevel
        {
            get { return _foodLevel; }
            set
            {
                _foodLevel = value;
                if(_foodLevel < 0)
                {
                    _foodLevel = 0;
                }
                else if(_foodLevel > 100)
                {
                    _foodLevel = 100;
                }
            }
        }

        public Int32 HappinessLevel
        {
            get { return _happinessLevel; }
            set
            {
                _happinessLevel = value;
                if(_happinessLevel < 0)
                {
                    _happinessLevel = 0;
                }
                else if (_happinessLevel > 100)
                {
                    _happinessLevel = 100;
                }
            }
        }
        public Int32 TimeUntilNextActivity { get; set; }

        public Int32 Money { get; set; }

        public Int32 Age { get; set; }

        public Status CurrentStatus { get;  set; }

        #endregion

        #region Constructor

        public Visitor(Int32 id, Tuple<Int32, Int32> coord, Tuple<Int32, Int32> tileCoord) : base(id, coord, tileCoord)
        {
            Random random = new Random();

            AdrenalinLevel = random.Next(1,100);
            FoodLevel = random.Next(59, 100);
            HappinessLevel = random.Next(59,80);
            TimeUntilNextActivity = 0;
            Money = random.Next(MinMoney, MaxMoney + 1);
            Age = 0;
        }

        #endregion

        #region Public methods

        public void LevelsChange()
        {
            Random random = new Random();
            if (random.Next(0, 20) < 2)
            {
                --FoodLevel;
            }
            if (random.Next(0, 20) < 2)
            {
                --HappinessLevel;
                if (FoodLevel < 60)
                {
                    --HappinessLevel;
                }
                if (HappinessLevel == 0)
                {
                    CurrentStatus = Status.SAD;
                }
            }
        }

        public void ChooseStatus()
        {
            if(HappinessLevel == 0)
            {
                CurrentStatus = Status.SAD;
            }
            else if (HappinessLevel < 60)
            {
                CurrentStatus = Status.UNHAPPY;
            }
            else if (FoodLevel < 60)
            {
                CurrentStatus = Status.HUNGRY;
            } 
            else
            {
                CurrentStatus = Status.SATISFIED;
            }
        }

        #endregion
    }
}
