﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HELLo_World.Model.StaticData
{
    public class BuildingData
    {
        #region Properties

        public List<CateringData> CateringData { get; set; }
        public List<EntertainmentData> EntertainmentData { get; set; }
        public RoadData RoadData { get; set; }
        public GateData GateData { get; set; }

        #endregion

        #region Constructor

        public BuildingData()
        {
            CateringData = new List<CateringData>();
            EntertainmentData = new List<EntertainmentData>();
        }

        #endregion

        #region Public methods

        public StaticBuildingData GetBuilding(Int32 bId)
        {
            if(bId == -1)
            {
                return GateData;
            }
            if (bId == 0)
            {
                return RoadData;
            }
            if (bId > 0 && bId < 100)
            {
                return CateringData[bId - 1];
            }
            if (bId >= 100)
            {
                return EntertainmentData[bId - 101];
            }
            return null;
        }

        #endregion
    }
}
