﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HELLo_World.ViewModel.Fields
{
    public abstract class Field : ViewModelBase
    {
        public static Int32 ImageSize { get; set; }

        public abstract Tuple<Int32, Int32> Coord { get; set; }

        public Uri ImageSource { get; set; }

        public Tuple<Int32, Int32> Size
        {
            get { return new Tuple<Int32, Int32>(Height / 50, Width / 50); }
            set
            {
                Height = value.Item1 * ImageSize;
                Width = value.Item2 * ImageSize;

                if (value.Item1 == 0) Height = 1;
                if (value.Item2 == 0) Width = 1;
            }
        }

        public Int32 X { get; protected set; }
        public Int32 Y { get; protected set; }
        public Int32 Z { get; set; }
        public Int32 Width { get; private set; }
        public Int32 Height { get; private set; }
    }
}
