﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HELLo_World.ViewModel.ViewModels
{
    public class MainViewModel : ViewModelBase
    {
        private ViewModelBase _selectedViewModel;

        #region Properties

        public ViewModelBase SelectedViewModel
        {
            get { return _selectedViewModel; }
            set
            {
                if (value != _selectedViewModel)
                {
                    _selectedViewModel = value;
                    OnPropertyChanged(nameof(SelectedViewModel));
                    OnPropertyChanged(nameof(WindowHeight));
                    OnPropertyChanged(nameof(WindowWidth));
                }
            }
        }
        public Int32 WindowHeight { 
            get
            {
                if (SelectedViewModel is GameViewModel) return (SelectedViewModel as GameViewModel).WindowHeight;
                return 600;
            } 
        }
        public Int32 WindowWidth
        {
            get
            {
                if (SelectedViewModel is GameViewModel) return (SelectedViewModel as GameViewModel).WindowWidth;
                return 600;
            }
        }
        
        public DelegateCommand BuildCommand { get; private set; }
        public DelegateCommand DestroyCommand { get; private set; }
        public DelegateCommand ZoomOnCanvas { get; private set; }

        #endregion

        #region Constructor

        public MainViewModel()
        {
            BuildCommand = new DelegateCommand(param => {
                if (SelectedViewModel is GameViewModel)
                {
                    (SelectedViewModel as GameViewModel).BuildCommand.Execute(param);
                }
            });
            DestroyCommand = new DelegateCommand(param => {
                if (SelectedViewModel is GameViewModel)
                {
                    (SelectedViewModel as GameViewModel).DestroyCommand.Execute(param);
                }
            });
            ZoomOnCanvas = new DelegateCommand(param => {
                if (SelectedViewModel is GameViewModel)
                {
                    (SelectedViewModel as GameViewModel).ZoomOnCanvas.Execute(param);
                }
            });
        }

        #endregion
    }
}
