﻿using HELLo_World.ViewModel.EventArguments;
using System;
using System.Collections.Generic;
using System.Text;

namespace HELLo_World.ViewModel.ViewModels
{
    public class NewGameViewModel : ViewModelBase
    {
        private String _newGameName;

        #region Properties

        public String NewGameName
        {
            get { return _newGameName; }
            set
            {
                if (value != _newGameName)
                {
                    _newGameName = value;
                    OnPropertyChanged();
                }
            }
        }

        public DelegateCommand StartNewGameCommand { get; private set; }
        public DelegateCommand BackToTitleScreenCommand { get; private set; }

        #endregion

        #region Events

        public event EventHandler<StartNewGameEventArgs> StartNewGame;
        public event EventHandler BackToTitleScreen;

        #endregion

        #region Constructor

        public NewGameViewModel()
        {
            NewGameName = "New Rollercoaster";
            StartNewGameCommand = new DelegateCommand(param => (NewGameName != null && NewGameName != ""), param => OnStartNewGame(NewGameName));
            BackToTitleScreenCommand = new DelegateCommand(param => OnBackToTitleScreen());
        }

        #endregion

        #region Private event methods

        private void OnStartNewGame(String name)
        {
            StartNewGame?.Invoke(this, new StartNewGameEventArgs(name));
        }

        private void OnBackToTitleScreen()
        {
            BackToTitleScreen?.Invoke(this, EventArgs.Empty);
        }

        #endregion
    }
}
