﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HELLo_World.ViewModel.ViewModels
{
    public class SettingsViewModel : ViewModelBase
    {
        #region Fields

        private Int32 _ticketValue;
        private Int32 _maintainerValue;

        #endregion

        #region Properties

        public Int32 TicketValue
        {
            get { return _ticketValue; }
            set
            {
                if (value != _ticketValue)
                {
                    _ticketValue = value;
                    OnPropertyChanged();
                }
            }
        }

        public Int32 MaintainerValue
        {
            get { return _maintainerValue; }
            set
            {
                if (value != _maintainerValue)
                {
                    _maintainerValue = value;
                    OnPropertyChanged();
                }
            }
        }

        public DelegateCommand CloseSettingsCommand { get; private set; }
        public DelegateCommand SaveSettingsCommand { get; private set; }

        #endregion

        #region Events

        public event EventHandler CloseSettings;
        public event EventHandler SaveSettings;

        #endregion

        #region Constructor

        public SettingsViewModel()
        {
            CloseSettingsCommand = new DelegateCommand(param => OnCloseSettings());
            SaveSettingsCommand = new DelegateCommand(param => OnSaveSettings());
        }

        #endregion

        #region Private methods

        private void OnCloseSettings()
        {
            CloseSettings?.Invoke(this, EventArgs.Empty);
        }

        private void OnSaveSettings()
        {
            SaveSettings?.Invoke(this, EventArgs.Empty);
        }

        #endregion
    }
}
