﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HELLo_World.ViewModel.ViewModels
{
    public class TitleScreenViewModel : ViewModelBase
    {
        #region Commands

        public DelegateCommand NewGameCommand { get; private set; }
        public DelegateCommand LoadGameCommand { get; private set; }
        public DelegateCommand ExitGameCommand { get; private set; }

        #endregion

        #region Events

        public event EventHandler NewGame;
        public event EventHandler LoadGame;
        public event EventHandler ExitGame;

        #endregion

        #region Constructor

        public TitleScreenViewModel()
        {
            NewGameCommand = new DelegateCommand(param => OnNewGame());
            LoadGameCommand = new DelegateCommand(param => OnLoadGame());
            ExitGameCommand = new DelegateCommand(param => OnExitGame());
        }

        #endregion

        #region Private event methods

        private void OnNewGame()
        {
            NewGame?.Invoke(this, EventArgs.Empty);
        }

        private void OnLoadGame()
        {
            LoadGame?.Invoke(this, EventArgs.Empty);
        }

        private void OnExitGame()
        {
            ExitGame?.Invoke(this, EventArgs.Empty);
        }

        #endregion
    }
}
